<% response.buffer = true %>
<%   
'    Adrian Frost - CommentWorks XML to CommentAPI converter.
'    Copyright  2002-2003  Adrian Frost
'    Released under the GNU General Public License (see LICENCE.TXT)
%>
<!-- #include file="system_includes.asp" -->
<!-- #include file="timestamps.asp" -->
<!-- #include file="text_filter.asp" -->
<!-- #include file="hash.asp" -->
<html>
<head>
<title>CommentWorks XML -&gt; CommentAPI</title>
</head>
<body>
<h3>CommentWorks XML to CommentAPI file converter</h3>
<p>
<%
Function HumanToUnix2(datetime)
If datetime <> "" Then
	fyear = left(datetime,4)
	fmonth = right(left(datetime,7),2)
	fday = right(left(datetime,10),2)
	fhour = right(left(datetime,13),2)
	fminute = right(left(datetime,16),2)
	fsecond = right(datetime,2)
Else
	fday = Day(now)
	fmonth = Month(now)
	fyear = Year(now)
	fhour = Hour(now)
	fminute = Minute(now)
	fsecond = Second(now)
End If

time_stamp = (fhour*3600) + (fminute*60) + (fsecond)
date_target = DateSerial(fyear,fmonth,fday)
date_ref = DateSerial(1970,01,01)
date_stamp = DateDiff("s",date_ref,date_target)

unix_stamp = date_stamp + time_stamp
HumanToUnix2 = unix_stamp
End Function

' read XML files:

set fs=Server.CreateObject("Scripting.FileSystemObject")
set f=fs.GetFolder(Server.MapPath(writable_dir))
set fo=f.files
	For each file in fo
		If right(file.name,4) = ".xml" AND InStr(file.name,"comment") Then
			filestring = filestring & "#" & file.name

		End If
	Next
set fo = nothing
set f = nothing
set fs = nothing

filestring = right(filestring,len(filestring)-1)
filestring = trim(filestring)
filearray = split(filestring, "#")


	for x = 0 to ubound(filearray) - 1
		for y= 0 to ubound(filearray) - 1
			if filearray(y)>filearray(y+1) then
				temp=filearray(y+1)
				filearray(y+1)=filearray(y)
				filearray(y)=temp
			end if
		next
	next

For i = lbound(filearray) to ubound(filearray) step 1
	response.write filearray(i) 
	response.flush
	ConvertComments filearray(i)
	response.write "..... Done<br />"
	response.flush
Next

' work in two passes - read all 


Public Sub ConvertComments(targetFile)
	Set objXMLDoc = Server.CreateObject("Microsoft.XMLDOM")
	objXMLDoc.async = false 
	objXMLDoc.load(server.mappath(writable_dir & targetFile))

	Set xmlRoot = objXMLDoc.documentElement
	Set threads = xmlRoot.getElementsByTagName("thread")
	n_threads = threads.length


	For count = 0 to n_threads-1

		threadID = threads.item(count).getAttribute("id")

		' check existence of RX file
		' If doesn't exist - create it
		' Then fill it:

		set fls=Server.CreateObject("Scripting.FileSystemObject")
		If fls.FileExists(server.mappath(writable_dir & subIncoming & subSlash & "rx" & threadID & ".xml")) = false Then
			Set objXMLNewDoc = Server.CreateObject(bw_xmlCheck) 
			Set procCmt = objXMLNewDoc.createProcessingInstruction("xml","version=""1.0"" encoding=""" & encode_as & """")
			objXMLNewDoc.appendChild(procCmt)

			Set rootCmt = objXMLNewDoc.createElement("incoming")
			objXMLNewDoc.appendChild(rootCmt)

			Set objAttr = objXMLNewDoc.createAttribute("postid") 
			Set xmlRoot = objXMLNewDoc.documentElement
		
			xmlRoot.setAttribute "postid", threadID

			objXMLNewDoc.save(server.mappath(writable_dir & subIncoming & subSlash & "rx" & threadID & ".xml"))
			Set objXMLNewDoc = nothing

		End If

		
		Set xmlRoot = objXMLDoc.documentElement.childNodes(count)
		Set comments = xmlRoot.getElementsByTagName("comment")
		n_comments = comments.length

		For j = 0 to n_comments-1
			cmtDateTime = xmlRoot.childNodes(j).childNodes(0).text
			cmtName = xmlRoot.childNodes(j).childNodes(1).text
			cmtMail = xmlRoot.childNodes(j).childNodes(2).text
			cmtURL = xmlRoot.childNodes(j).childNodes(3).text
			cmtIP = xmlRoot.childNodes(j).childNodes(4).text
			cmtText = xmlRoot.childNodes(j).childNodes(5).text
			
			If cmtMail <> "" Then
				cmtMail = " (" & cmtMail & ")"
			End If

			cmtText = replace(cmtText,"<br>",vbCrLf)
			cmtText = replace(cmtText,"<br />",vbCrLf)
			cmtText = stripHTML(cmtText,true)


			' open RX file and fill it with stuff...
			Set objXMLNewDoc2 = Server.CreateObject(bw_xmlCheck)
			objXMLNewDoc2.async = false 
			objXMLNewDoc2.load(server.mappath(writable_dir & subIncoming & subSlash & "rx" & threadID & ".xml"))
	
			Set xmlNewRoot2 = objXMLNewDoc2.documentElement
			Set objNewItem = objXMLNewDoc2.createElement("item")
			xmlNewRoot2.appendChild(objNewItem)

			Set objNewSubItem = objXMLNewDoc2.createElement("title")
			objNewSubItem.text = ""
			objNewItem.appendChild(objNewSubItem)

			Set objNewSubItem = objXMLNewDoc2.createElement("link")
			objNewSubItem.text = cmtURL
			objNewItem.appendChild(objNewSubItem)

			Set objNewSubItem = objXMLNewDoc2.createElement("description")
			objNewSubItem.text = cmtText
			objNewItem.appendChild(objNewSubItem)

			Set objNewSubItem = objXMLNewDoc2.createElement("author")
			objNewSubItem.text = cmtName & cmtMail
			objNewItem.appendChild(objNewSubItem)

			Set objNewSubItem = objXMLNewDoc2.createElement("pubDate")
			uCmtDT = HumanToUnix2(cmtDateTime)
			objNewSubItem.text = UnixToRSS(uCmtDT,"rfc822")
			objNewItem.appendChild(objNewSubItem)

			Set objNewSubItem = objXMLNewDoc2.createElement("category")
			objNewSubItem.text = "bwForm"
			objNewItem.appendChild(objNewSubItem)

			Set objNewGuid = objXMLDoc.createElement("guid")
			objNewGuid.setAttribute "isPermalink","false"
			objNewGuid.text = miniHash(UnixtoRSS(uCmtDT,"rfc822") & "bwForm") 
			objNewItem.appendChild(objNewGuid)


			objXMLNewDoc2.save(server.mappath(writable_dir & subIncoming & subSlash & "rx" & threadID & ".xml"))

			Set objXMLNewDoc2 = nothing
		Next

		

	Next
	Set objXMLDoc = nothing
End Sub



%>
</p>
</body>
</html>