<%   
'    Adrian Frost - BlogWorks XML 1.3.0
'    Copyright  2002-2003  Adrian Frost
'    Released under the GNU General Public License (see LICENCE.TXT)
%>
<!-- #include file="prefs_include.asp" -->
<!-- #include file="paths.asp" -->
<!-- #include file="xmldom_check.asp" -->
<!-- #include file="timestamps.asp" -->
<!-- #include file="text_filter.asp" -->
<!-- #include file="xmlsubs.asp" -->
<!-- #include file="pingback_functions.asp" -->
<%
Dim typeFlag, incURL, isForm, incID, incTitle, incLink, incSource, incAuthor, incDescription, incName, incEmail, xmlString

' Let's set up our XML doc to receive the incoming 'stuff'
set objXMLdoc = Server.CreateObject(bw_xmlCheck)
objXMLdoc.async = false
objXMLdoc.setProperty "SelectionLanguage","XPath" 


' build our own little mini XML-RPC one function server.
objXMLdoc.load(Request)
On error resume Next
set mName = objXMLDoc.documentElement.selectSingleNode("//methodName")
If err <> 0 then
	response.write writeFaultXML("0", "No XML-RPC methodName in received XML.")
	response.end 
End If

methodName = mName.text
If methodName = "pingback.ping" Then
	Set objLst = objXMLDoc.documentElement.getElementsByTagName("param")
	If (objLst.length > 0 ) Then
		Dim argList()
		ReDim argList(objLst.length)
		For i = 0 to objLst.length - 1
			Set tmp = objLst.item(i).childNodes(0)
			argList(i) = tmp.text
		Next
	End if

	Dim sourceURL,targetURL
	sourceURL = argList(0)
	targetURL= argList(1)
			
	pingBackCheckResult = pingBackCheck(sourceURL,targetURL)	
	' pingBackCheckResult = "OK"
	' pingBackCheck will attempt to:
	' 1 - check whether targetURL exists for this system (fail error 32 or 33)
	' 2 - check sourceURL if exists then (fail error 16)
	' 3 - fetch sourceURL and check for targetURL (fail error 17)
	
	Select Case pingBackCheckResult
		Case "0"
			response.write writeFaultXML("0", "PingBack failed with a General Error.")
			response.end
		Case "16"
			response.write writeFaultXML("16", "The source URI does not exist.")
			response.end
		Case "17"
			response.write writeFaultXML("17", "The source URI does not contain a link to the target URI, and so cannot be used as a source.")
			response.end
		Case "32"
			response.write writeFaultXML("32", "The specified target URI does not exist. ")
			response.end
		Case "33"
			response.write writeFaultXML("33", "The specified target URI cannot be used as a target. It either doesn't exist, or it is not a pingback-enabled resource. ")
			response.end
		Case Else
			xmlString = "<?xml version=""1.0""?>" _
					& "<item>" _
					& "<link>" & sourceURL & "</link>" _
					& "<description>" & pingBackCheckResult & "</description>" _
					& "</item>"


			incID = right(targetURL,len(targetURL) - inStr(targetURL,"#"))
			' Set up a new XML Doc
			set objXMLdoc = Server.CreateObject(bw_xmlCheck)
			objXMLdoc.async = false
			objXMLdoc.setProperty "SelectionLanguage","XPath" 

			objXMLdoc.loadXML(xmlString)
			typeFlag = "pingBack"
	End Select
Else
	response.write writeFaultXML("0", "The XML-RPC sever at this URL only accepts PingBack calls.")
	response.end
End If


sXPath = "//item/*"

Set objNewItem = objXMLdoc.createElement("item")
set objNodes = objXMLdoc.documentElement.selectNodes(sXPath)

For each Node in objNodes
If Instr(Node.nodeName,":") = False Then  ' refuse namespaced elements. Basic RSS 2.0 only.
	If InStr(Node.nodeName,"pubDate") = False Then
		Set objNewSubItem = objXMLDoc.createElement(node.nodeName)
		' All HTML is stripped for safety's sake - stops images, links and scripts
		objNewSubItem.text = StripHTML(node.text,true)
		objNewItem.appendChild(objNewSubItem)
	End If
End If
Next

Set objNewDate = objXMLDoc.createElement("pubDate")
objNewDate.text = UnixtoRSS(HumanToUnix(""),"rfc822")

' objNewDate.text = CreateDateTime("rss")
objNewItem.appendChild(objNewDate)

Set objNewCategory = objXMLDoc.createElement("category")
objNewCategory.text = typeFlag
objNewItem.appendChild(objNewCategory)


set fls=Server.CreateObject("Scripting.FileSystemObject")
If fls.FileExists(server.mappath(writable_dir & subIncoming & subSlash & "rx" & incID & ".xml")) = true Then
	Set objXMLchanges = Server.CreateObject(bw_xmlCheck)
	objXMLchanges.async = false 
	objXMLchanges.load(server.mappath(writable_dir & subIncoming & subSlash & "rx" & incID & ".xml"))
	Set changesRoot = objXMLchanges.documentElement
	changesRoot.appendChild objNewItem
	objXMLchanges.save(server.mappath(writable_dir & subIncoming & subSlash & "rx" & incID & ".xml"))
	set objXMLdoc = nothing
	set objXMLchanges = nothing
Else
	Set objNewXMLDoc = Server.CreateObject(bw_xmlCheck) 
	Set procTB = objNewXMLDoc.createProcessingInstruction("xml","version=""1.0"" encoding=""" & encode_as & """")
	objNewXMLDoc.appendChild(procTB)
	Set rootTB = objNewXMLDoc.createElement("incoming")
	objNewXMLDoc.appendChild(rootTB)
	Set objAttr = objNewXMLDoc.createAttribute("postid") 
	Set xmlNewRoot = objNewXMLDoc.documentElement
	xmlNewRoot.setAttribute "postid", incID 

	xmlNewRoot.appendChild objNewItem

	Set fs = Server.CreateObject("Scripting.FileSystemObject")
	If fs.FolderExists(server.mappath(writable_dir & subIncoming)) = True Then
		objNewXMLDoc.save(server.mappath(writable_dir & subIncoming & subSlash & "rx" & incID & ".xml"))
	Else
		GeneralError = "tb_rx_xml1"
	End If
	set fs = nothing
	Set objXMLDoc = nothing

End If
set fls = nothing

resp = "PingBack ping received. No Errors!"
response.write resp


Function writeFaultXML(errNum, errDesc)
	xmlText = "<?xml version=""1.0"" encoding=""" & encode_as &"""?>" _
	& "<methodResponse>" _
	& "<fault>" _
	& "<value>" _
	& "<struct>" _
	& "<member>" _
	& "<name>faultCode</name><value><int>" _
	& errNum _
	& "</int></value>" _
	& "</member>" _
	& "<member>" _
	& "<name>faultString</name><value><string>" _
	& Server.HTMLEncode(errDesc) _
	& "</string></value>" _
	& "</member>" _
	& "</struct>" _
	& "</value>" _
	& "</fault>" _
	& "</methodResponse>"

writeFaultXML = xmlText
End Function
%>

