<%   
'    Adrian Frost - BlogWorks XML 1.3.0
'    Copyright  2002-2003  Adrian Frost
'    Released under the GNU General Public License (see LICENCE.TXT)
%>
<%
' The prefs120.asp file contains settings that I decided not to include in the settings page and which
' don't appear in prefs.asp either because they are relevant to a new version of BW and I didn't want to
' add to the original prefs.asp file and thus make people re-setup their blogs.
' Each setting is detailed with possible options.

Dim runFlat, adminRelOverride, imagesRelOverride,bwBar,pbUrls,eventLogging

' "Run Flat" enables a BW blog to run using only the writable_dir directory without sub directories.
' useful if you're having problems with directory permissions.
' Please see the help file for more information.
' default = false (don't change it to "true" unless you are having real directory permission problems)
runFlat = false


' If admin_url doesn't point to a subdirectory of publish_url then edit this setting to reflect the relative path between your
' publishing directory and your admin directory.
adminRelOverride = ""


' If images_url doesn't point to a subdirectory of publish_url then edit this setting to reflect the relative path between your
' publishing directory and your admin directory.
imagesRelOverride = ""


' Turn off the blue BlogWorks bar to give yourself more screen real-estate
' true = on, false = off
' default = true
bwBar = true


' PingBack URLs - whether by default URLs in a post are PingBacked or not.
' Options: true - all URLs are pinged, false - no URLs are pinged. 
' This setting affects the checkbox on the 'New Post' page.
pbUrls = true

' Event Logging for Incoming events:
' Only set to 'true' if directed by BlogWorks support.
eventLogging = false
%>
