<%   
'    Adrian Frost - BlogWorks XML 1.3.0
'    Copyright  2002-2003  Adrian Frost
'    Released under the GNU General Public License (see LICENCE.TXT)
%>
<!-- #include file="prefs_include.asp" -->
<!-- #include file="paths.asp" -->
<!-- #include file="xmldom_check.asp" -->
<!-- #include file="general_functions.asp" -->
<!-- #include file="tb_class.asp" -->
<!-- #include file="international.asp" -->
<%
Dim postID
Dim errNo
postID = request.querystring("id")
errNo = request.querystring("err")


Function itemBuilder(itemCat,itemDate,itemAuthor,itemSource,itemDescription,itemLink,itemTitle)
Select Case itemCat
Case "xmlItem"
	If itemTitle <> "" Then
		build = "<strong>" & itemTitle & "</strong><br />"
	End If

	If itemLink = "" Then
		buildLink = returnAuthor(itemAuthor)
	ElseIf itemLink <> "http://" Then
		buildLink = "<a href=""" & itemLink & """ target=""_blank"">" & returnAuthor(itemAuthor) & "</a>"
	Else
		buildLink = returnAuthor(itemAuthor)
	End If
	itemDescription = InsertHyperlinks(itemDescription)
	itemDescription = replace(itemDescription,chr(10),linebreaktag)
	build = build & itemDescription
	build = build & "<br />" & buildLink
	build = build & "<br /><small><em>" & infCommentXML & "</em></small>"
Case "bwForm"
	If itemTitle <> "" Then
		build = "<strong>" & itemTitle & "</strong><br />"
	End If

	If itemLink = "" Then
		buildLink = returnAuthor(itemAuthor)
	ElseIf itemLink <> "http://" Then
		buildLink = "<a href=""" & itemLink & """ target=""_blank"">" & returnAuthor(itemAuthor) & "</a>"
	Else
		buildLink = returnAuthor(itemAuthor)
	End If
	itemDescription = InsertHyperlinks(itemDescription)
	itemDescription = replace(itemDescription,chr(10),linebreaktag)
	build = build & itemDescription
	build = build & "<br />" & buildLink
	build = build & "<br /><small><em>" & infCommentForm & "</em></small>"

Case "trackBack"
	If itemTitle <> "" Then
		build = "<strong>" & itemTitle & "</strong><br />"
	End If

	If itemLink = "" Then
		buildLink = itemSource
	ElseIf itemLink <> "http://" Then
		buildLink = "<a href=""" & itemLink & """ target=""_blank"">" & itemSource & "</a>"
	Else
		buildLink = returnAuthor(itemAuthor)
	End If
	itemDescription = InsertHyperlinks(itemDescription)
	itemDescription = replace(itemDescription,chr(10),linebreaktag)
	build = build & itemDescription
	build = build & "<br />" & buildLink
	build = build & "<br /><small><em>" & infCommentTB & "</em></small>"

Case "pingBack"
	build = "<a href=""" & itemLink & """ target=""_blank"">" & itemLink & "</a><br /><small><em>" & infCommentPB & "</em></small>"

End Select
itemBuilder = build
End Function

Private Function returnAuthor(author)
If author <> "" Then
	If InStr(author,"@") Then
		posOB = InStr(author,"(")
		cmtName = left(author,posOB-2)
	Else
		cmtName = author
	End If
Else
	cmtName = infCommentAnonymous
End If

returnAuthor = cmtName
End Function

Function InsertHyperlinks(inText)
Dim objRegExp, strBuf
Dim objMatches, objMatch
Dim Value, ReplaceValue, iStart, iEnd

strBuf = ""
iStart = 1
iEnd = 1
Set objRegExp = New RegExp

objRegExp.Pattern = "\b(www|http|\S+@)\S+\b"  ' Match URLs and emails
objRegExp.IgnoreCase = True                   ' Set case insensitivity.
objRegExp.Global = True                       ' Set global applicability.
Set objMatches = objRegExp.Execute(inText)
For Each objMatch in objMatches
	iEnd = objMatch.FirstIndex
	strBuf = strBuf & Mid(inText, iStart, iEnd-iStart+1)
	If InStr(1, objMatch.Value, "@") Then
		strBuf = strBuf & GetHref(objMatch.Value, "EMAIL", "_blank")
	Else
		strBuf = strBuf & GetHref(objMatch.Value, "WEB", "_blank")
	End If
	iStart = iEnd+objMatch.Length+1
Next
strBuf = strBuf & Mid(inText, iStart)
InsertHyperlinks = strBuf
End Function


Function GetHref(url, urlType, Target)
Dim strBuf
strBuf = "<a href="""
	If UCase(urlType) = "WEB" Then
		If LCase(Left(url, 7)) <> "http://" Then
			strBuf = "<a href=""http://" & url & """ target=""" & Target & """>" & url & "</a>"
		Else
			strBuf = "<a href=""" & url & """ target=""" & Target & """>" & url & "</a>"
		End If
	ElseIf UCase(urlType) = "EMAIL" Then
		strBuf = "<a href=""mailto:" & url & """ target=""" & Target & """>" & url & "</a>"
	End If
  
GetHref = strBuf
End Function

 

%>

<?xml version="1.0"?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xml:lang="en" xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>BlogWorks XML&nbsp;-&nbsp;<%= titlTBcAPI %></title>
<link rel="stylesheet" href="rx_display_basic.css" type="text/css" />
<style type="text/css" media="all">
@import "rx_display_internal.css";
</style>
</head>
</body>
<%

set objTBs = new clsTrackBack
objTBs.AdminURL = admin_url
objTBs.WritableURL = writable_url
objTBs.PostID = postID

objTBs.Initialize

response.write "<div id=""tbURL""><h1>" & titlTBcAPI & "</h1>" & objTBs.URL & "</div>"

If errNo = "1.0" then
response.write "<div id=""cmtError""><strong>" & infCommentError & "</strong></div>"
End If

Set objPings = objTBs.Pings
Dim tbCount
If objPings.Length <> 0 Then
%>
<div id="tbPings">
<%
'Dim tbCount
For tbCount = 0 to objPings.Length - 1
	Set objPing = objPings.Item(tbCount)
	
	' gives a nice way to have alternating div colours
	If tbCount Mod 2 = 1 Then
		bgcol = "tbDivOdd"
	Else
		bgcol = "tbDivEven"
	End If

cmtTitle = objPing.title
cmtLink = objPing.link
cmtDescription = objPing.description
cmtSource = objPing.source
cmtAuthor = objPing.author
cmtPubDate = objPing.time
cmtCategory = objPing.category
%>
<div id="<%= bgcol %>">
<%= itemBuilder(cmtCategory,cmtPubDate,cmtAuthor,cmtSource,cmtDescription,cmtLink,cmtTitle)%>
<div class="rxDelete"><a href="delete_comment.asp?node=<%= tbCount %>&id=<%= postID %>">Delete</a></div>
</div>
<%
Next
End If
Set objTBs = nothing
%>
</div>
</body>
</html>
