<%
Function GetTrackBacks(strUrl)
Dim split_anchor, hash_pos, url, whole_url

url = trim(strUrl)
whole_url = url
' If there's a # we got most likely a permalink ext so let's split it off, 
' save it and use it later to try and return a single TB url

If InStr(url,"#") Then
hash_pos = InStr(url,"#")
split_anchor = right(url,len(url)-hash_pos+1)
url = left(url,hash_pos-1)
End If

On Error Resume Next
Err = 0

If left(url,7) <> "http://" Then
url = "http://" & url
End If


'Initialise XMLHTTP object
set valid_doc = Server.CreateObject("Microsoft.XMLHTTP")
If Err <> 0 Then
	GetTrackBacks = "8.1" 'Faulty object creation
	Exit Function
End If

'Open the connection
valid_doc.open "GET",url,false

If Err <> 0 Then
	GetTrackBacks = "8.2" 'duff URL
	Exit Function
End If

'Add HTTP headers
valid_doc.setRequestHeader "User-Agent","BlogWorks TrackBack RDF Finder v1.2"
valid_doc.setRequestHeader "Pragma","no-cache"
valid_doc.setRequestHeader "Cache-Control", "no-cache"


'Send the request
valid_doc.send 
If Err <> 0 Then
	GetTrackBacks = "8.3" 'Couldn't send request
	Exit Function
End If


response_html = (valid_doc.responseText)

set valid_doc = nothing

If InStr(response_html,"<rdf:RDF") Then
	'Try to extract all the RDF into a RegExp collection
	Dim regEx, Match, Matches 
	Set regEx = New RegExp
	regEx.Pattern = "<rdf:RDF.*(.|\n)*?</rdf:RDF>" 
	regEx.IgnoreCase = True
	regEx.Global = True
	Set Matches = regEx.Execute(response_html)
	For Each Match in Matches   ' Iterate Matches collection.

		' Load up each match and see if we can extract the RDF info.
		Set objXML = Server.CreateObject(bw_xmlCheck)
		objXML.async = false 
		objXML.loadXML(Match.Value)

		If objXML.parseError.errorCode <> 0 Then 
			GetTrackBacks = "8.4" 'Couldn't load RDF
			Exit Function
		End If 

		Set xmlRoot = objXML.documentElement


		trackbackping = xmlRoot.childNodes(0).getAttribute("trackback:ping")
		rdfabout = xmlRoot.childNodes(0).getAttribute("rdf:about") 
		dctitle = xmlRoot.childNodes(0).getAttribute("dc:title")
		about = xmlRoot.childNodes(0).getAttribute("about")

		If InStr(rdfabout,whole_url) Then
			GetTrackBacks = split(trackbackping & "!$!" & dctitle & "|","|")
			Exit Function
		End If

		If InStr(about,whole_url) Then
			GetTrackBacks = split(trackbackping & "!$!" & dctitle & "|","|")
			Exit Function
		End If

		If objXML.parseError.errorCode <> 0 Then 
			GetTrackBacks = "8.5"  'duff RDF
			Exit Function
		End If 


		If IsNull(trackbackping) Then
			If IsNull(rdfabout) Then
				url_to_show = about
			Else
				url_to_show = rdfabout
			End If
		Else
			url_to_show = trackbackping
		End If


		ret_str = ret_str & "|" & url_to_show & "!$!" & dctitle
	
		Set objXML = nothing
	Next
		ret_str = right(ret_str,len(ret_str)-1)
		ret_str = trim(ret_str)
		GetTrackBacks = split(ret_str,"|")

Else
	GetTrackBacks = "8.6"   'no rdf available
End If
End Function
%>