<% Response.buffer = true %>
<%  
'    Adrian Frost - BlogWorks XML 1.3.0
'    Copyright  2002-2003  Adrian Frost
'    Released under the GNU General Public License (see LICENCE.TXT)
%>
<!-- #include file="system_includes.asp" -->
<!-- #include file="template_functions.asp" -->
<!-- #include file="adovbs.inc" -->
<!-- #include file="timestamps.asp" -->
<!-- #include file="datetime.asp" -->
<!-- #include file="engine.asp" -->
<%
Function letterHash(sInput) 
	Dim a, b, c, i, sTemp
	a = 1  
	For i = 1 To Len(sInput)    
		a = Sqr(a * Asc(Mid(sInput, i, 1)))
		b = b + a
	Next  

	' make sure the number generated is the same each time given the same seed.
	Rnd (-1)
	Randomize b

	For i = 0 To 7	
		c = cInt(25 * Rnd + 97)
		sTemp = sTemp & Chr(c)
	Next 
	letterHash = sTemp
End Function 


mode = request.querystring("mode")

Select Case mode

Case "feed"
	feedType = request.form("synd_feed_type")
	feedName = request.form("synd_feed_name")
	feedFileName = request.form("synd_file_name")

	feedInfo = split(feedType,"#")
	feedDefFile = feedInfo(0)
	feedDefName = feedInfo(1)

	'generate a unique ID for the template - this it's 'handle' within BlogWorks
	feedAlias = letterHash(now())

	Dim arrFeedElements(4),arrFeedContents(4)

	arrFeedElements(0) = "alias"
	arrFeedElements(1) = "name"
	arrFeedElements(2) = "type"
	arrFeedElements(3) = "filename"
	arrFeedElements(4) = "definition"

	arrFeedContents(0) = feedAlias
	arrFeedContents(1) = feedName
	arrFeedContents(2) = feedDefName
	arrFeedContents(3) = feedFileName
	arrFeedContents(4) = feedDefFile

	retVal = addXMLFragment("syndication.xml",blog_ID,"feed",arrFeedElements,arrFeedContents)

	CreateTemplates feedDefFile,feedAlias & blog_ID

	' If there are posts let's publish the new feed as well
	chkArchives = CheckArchivesExist(blog_id)
	If chkArchives = true Then
		PublishSyndicationFile blog_id,feedFileName,feedAlias
	End If
	response.redirect "syndicate.asp?msg=10.0"

Case "category"
	action = request.form("submit_cat")
	If action = btnSaveCat Then
		catAlias = request.form("hid_cat_alias")
		newCatName = request.form("cat_name")
		newCatFileName = request.form("cat_file_name")
		
		Dim arrEditCatElements(2),arrEditCatContents(2)
		arrEditCatElements(0) = "alias"
		arrEditCatElements(1) = "name"
		arrEditCatElements(2) = "filename"

		arrEditCatContents(0) = catAlias
		arrEditCatContents(1) = newCatName
		arrEditCatContents(2) = newCatFileName
	
		retVal = editXMLFragment("categories.xml",blog_ID,"category",arrEditCatElements,arrEditCatContents)

		If retVal = true Then
			response.redirect "categories.asp?msg=9.02"
		Else
			response.redirect "categories.asp?msg=9.2"
		End If
	Else
		Set catList = listNodes(blog_id,"category","categories.xml")
		If catList.Length = 0 Then
			catDefault = "true" 
		Else
			catDefault = "false"
		End If

		catName = request.form("cat_name")
		catFileName = request.form("cat_file_name")
		catNewID = addZeros(CatCount(true))

		catAlias = letterHash(now())

		Dim arrCatElements(4),arrCatContents(4)
		arrCatElements(0) = "alias"
		arrCatElements(1) = "default"
		arrCatElements(2) = "name"
		arrCatElements(3) = "id"
		arrCatElements(4) = "filename"
	

		arrCatContents(0) = catAlias
		arrCatContents(1) = catDefault
		arrCatContents(2) = catName
		arrCatContents(3) = catNewID
		arrCatContents(4) = catFileName

		retVal = addXMLFragment("categories.xml",blog_ID,"category",arrCatElements,arrCatContents)

		CreateTemplates "categorypagesdef.htm",catAlias & blog_ID
		Dim modFind(0),modReplace(0)
		modFind(0) = "##CAT_ID##"
		modReplace(0) = catNewID

		ModTemplate catAlias & blog_ID,"plate",modFind,modReplace
		response.redirect "categories.asp?msg=9.0"
	End If
Case "ping"
	action = request.form("submit_ping")
	If action = btnSavePing Then
		pingEditAlias = request.form("hid_ping_alias")
		pingEditFromName = request.form("ping_from_name")
		pingEditFromURL = request.form("ping_from_url")
		pingEditToName = request.form("ping_to_name")
		pingEditToURL = request.form("ping_to_url")
		pingEditToHost = request.form("ping_to_host")
		If pingEditToHost = infIfKnown Then
			pingEditToHost = ""
		End If

		Dim arrPingEditElements(5),arrPingEditContents(5)
		arrPingEditElements(0) = "alias"
		arrPingEditElements(1) = "fromName"
		arrPingEditElements(2) = "fromURL"
		arrPingEditElements(3) = "toName"
		arrPingEditElements(4) = "toURL"
		arrPingEditElements(5) = "toHost"
	

		arrPingEditContents(0) = pingEditAlias
		arrPingEditContents(1) = pingEditFromName
		arrPingEditContents(2) = pingEditFromURL
		arrPingEditContents(3) = pingEditToName
		arrPingEditContents(4) = pingEditToURL
		arrPingEditContents(5) = pingEditToHost
	
		retVal = editXMLFragment("pings.xml",blog_ID,"ping",arrPingEditElements,arrPingEditContents)

		If retVal = true Then
			response.redirect "pinging.asp?msg=11.02"
		Else
			response.redirect "pinging.asp?msg=11.2"
		End If
	Else
		pingFromName = request.form("ping_from_name")
		pingFromURL = request.form("ping_from_url")
		pingToName = request.form("ping_to_name")
		pingToURL = request.form("ping_to_url")
		pingToHost = request.form("ping_to_host")
		If pingToHost = infIfKnown Then
			pingToHost = ""
		End If
		pingAlias = letterHash(now())

		Dim arrPingElements(5),arrPingContents(5)
		arrPingElements(0) = "alias"
		arrPingElements(1) = "fromName"
		arrPingElements(2) = "fromURL"
		arrPingElements(3) = "toName"
		arrPingElements(4) = "toURL"
		arrPingElements(5) = "toHost"
	

		arrPingContents(0) = pingAlias
		arrPingContents(1) = pingFromName
		arrPingContents(2) = pingFromURL
		arrPingContents(3) = pingToName
		arrPingContents(4) = pingToURL
		arrPingContents(5) = pingToHost

		retVal = addXMLFragment("pings.xml",blog_ID,"ping",arrPingElements,arrPingContents)

		response.redirect "pinging.asp?msg=11.0"
	End If
End Select


Function CatCount(blUpdate)
	set fls=Server.CreateObject("Scripting.FileSystemObject")
	If fls.FileExists(server.mappath(writable_dir & subData & subSlash & "category_count.txt")) = true Then
		flname = (server.mappath(writable_dir & subData & subSlash & "category_count.txt"))
		set txtfile = fls.OpenTextFile(flname, 1, 0)
		cat_count = txtfile.ReadAll
		txtfile.close
		set txtfile = nothing
	End If
	set fls = nothing

	If blUpdate = true Then
		cat_count = cat_count + 1
		set fileObj = Server.CreateObject("Scripting.FileSystemObject")
		fname = (server.mappath(writable_dir & subData & subSlash & "category_count.txt"))
		set txtfile = fileObj.CreateTextFile(fname,true)
		txtfile.writeline cat_count
		txtfile.close
		set txtfile = nothing
		set fileObj =nothing
	End If
	CatCount = cat_count
End Function
%>