<%   
'    Adrian Frost - BlogWorks XML 1.3.0
'    Copyright  2002-2003  Adrian Frost
'    Released under the GNU General Public License (see LICENCE.TXT)
%>
<%
Dim ord,blog_day_digit
Sub Ordinals()
If right(blog_day_digit,1) = "1" and blog_day_digit <> "11" Then
ord = "st"
ElseIf right(blog_day_digit,1) = "2" and blog_day_digit <> "12"  Then
ord = "nd"
ElseIf right(blog_day_digit,1) = "3" and blog_day_digit <> "13"  Then
ord = "rd"
Else
ord = "th"
End If
If left(blog_day_digit,1) = "0" Then
blog_day_digit = right(blog_day_digit,1)
End If
End Sub

Function ProcessDate(isodatetime,forceformat)
blog_date = isodatetime
blog_time = right(blog_date,8)
blog_time = left(blog_time,5)

blog_year = left(blog_date,4)
blog_month_digit = left(blog_date,6)
blog_month_digit = right(blog_month_digit,2)
blog_day_digit = left(blog_date,8)
blog_day_digit = right(blog_day_digit,2)

created_day = Weekday(DateSerial(blog_year,blog_month_digit,blog_day_digit))

use_format = date_format

If forceformat = "1" then
use_format = "Weekday, dd[ord] Month, yyyy"
End If

Select Case blog_month_digit
Case "01"
blog_month = bl_month1
blog_short_month = bl_monthsh1
Case "02"
blog_month = bl_month2
blog_short_month = bl_monthsh2
Case "03"
blog_month = bl_month3
blog_short_month = bl_monthsh3
Case "04"
blog_month = bl_month4
blog_short_month = bl_monthsh4
Case "05"
blog_month = bl_month5
blog_short_month = bl_monthsh5
Case "06"
blog_month = bl_month6
blog_short_month = bl_monthsh6
Case "07"
blog_month = bl_month7
blog_short_month = bl_monthsh7
Case "08"
blog_month = bl_month8
blog_short_month = bl_monthsh8
Case "09"
blog_month = bl_month9
blog_short_month = bl_monthsh9
Case "10"
blog_month = bl_month10
blog_short_month = bl_monthsh10
Case "11"
blog_month = bl_month11
blog_short_month = bl_monthsh11
Case "12"
blog_month = bl_month12
blog_short_month = bl_monthsh12
End Select

Select case created_day
case "1"
blog_day = bl_day1
blog_short_day = bl_daysh1
case "2"
blog_day = bl_day2
blog_short_day = bl_daysh2
case "3"
blog_day = bl_day3
blog_short_day = bl_daysh3
case "4"
blog_day = bl_day4
blog_short_day = bl_daysh4
case "5"
blog_day = bl_day5
blog_short_day = bl_daysh5
case "6"
blog_day = bl_day6
blog_short_day = bl_daysh6
case "7"
blog_day = bl_day7
blog_short_day = bl_daysh7
End Select

' replace Statements
blog_date = Replace(use_format,"yyyy", blog_year,1,-1,0)
blog_date = Replace(blog_date,"yy", right(blog_year,2),1,-1,0)
blog_date = Replace(blog_date,"mm", blog_month_digit,1,-1,0)
blog_date = Replace(blog_date,"Month", blog_month,1,-1,0)
blog_date = Replace(blog_date,"month", lcase(blog_month),1,-1,0)
blog_date = Replace(blog_date,"MONTH", ucase(blog_month),1,-1,0)
blog_date = Replace(blog_date,"Mn", blog_short_month,1,-1,0)
blog_date = Replace(blog_date,"mn", lcase(blog_short_month),1,-1,0)
blog_date = Replace(blog_date,"MN", ucase(blog_short_month),1,-1,0)
If inStr(1,use_format,"[ord]",1) Then
	If left(blog_day_digit,1) = "0" Then
		blog_day_digit = right(blog_day_digit,1)
	End If
End If
blog_date = Replace(blog_date,"dd", blog_day_digit,1,-1,0)
blog_date = Replace(blog_date,"Weekday", blog_day,1,-1,0)
blog_date = Replace(blog_date,"weekday", lcase(blog_day),1,-1,0)
blog_date = Replace(blog_date,"WEEKDAY", ucase(blog_day),1,-1,0)
blog_date = Replace(blog_date,"Wday", blog_short_day,1,-1,0)
blog_date = Replace(blog_date,"wday", lcase(blog_short_day),1,-1,0)
blog_date = Replace(blog_date,"WDAY", ucase(blog_short_day),1,-1,0)
Call Ordinals
If blog_lang = "en" Then
blog_date = Replace(blog_date,"[ord]", lcase(ord),1,-1,0)
blog_date = Replace(blog_date,"[ORD]", ucase(ord),1,-1,0)
Else
blog_date = Replace(blog_date,"[ord]","")
End If
ProcessDate = blog_date
End Function

Function ProcessTime(isodatetime,forceformat)
blog_time = right(isodatetime,8)
blog_hour = left(blog_time,2)
blog_minute = left(blog_time,5)
blog_minute = right(blog_minute,2)
blog_second = right(blog_time,2)

use_format = time_format

If forceformat = "1" Then
use_format = "HH:MM"
End If

'ampm = lcase(TimeSerial(blog_hour,blog_minute,"00"))
'ampm = right(ampm,2)

If Instr(1,use_format,"ampm",1) Then
	'convert hours after 12 to 12 hour clock...
	If blog_hour > 12  Then
		blog_hour = blog_hour - 12
		ampm = "pm"
	'End If
	ElseIf left(blog_hour,1) = "0" Then
		blog_hour = right(blog_hour,1)
		ampm = "am"
	'End If
	ElseIf blog_hour = "0" Then
		blog_hour = "12"
		ampm = "am"
	Else
		blog_hour = blog_hour
		ampm = "am"
	End If 
End If

blog_time = Replace(use_format,"HH", blog_hour,1,-1,0)
blog_time = Replace(blog_time,"MM", blog_minute,1,-1,0)
blog_time = Replace(blog_time,"SS", blog_second,1,-1,0)
blog_time = Replace(blog_time,"ampm", lcase(ampm),1,-1,0)
blog_time = Replace(blog_time,"AMPM", ucase(ampm),1,-1,0)
ProcessTime = blog_time
End Function


Function ProcessArchiveDate(datetime,forceformat)
blog_date = datetime
blog_year = left(blog_date,4)
blog_month_digit = left(blog_date,6)
blog_month_digit = right(blog_month_digit,2)

use_format = archive_date_format

If forceformat = "1" then
use_format = "Month, yyyy"
End If

Select Case blog_month_digit
Case "01"
blog_month = bl_month1
blog_short_month = bl_monthsh1
Case "02"
blog_month = bl_month2
blog_short_month = bl_monthsh2
Case "03"
blog_month = bl_month3
blog_short_month = bl_monthsh3
Case "04"
blog_month = bl_month4
blog_short_month = bl_monthsh4
Case "05"
blog_month = bl_month5
blog_short_month = bl_monthsh5
Case "06"
blog_month = bl_month6
blog_short_month = bl_monthsh6
Case "07"
blog_month = bl_month7
blog_short_month = bl_monthsh7
Case "08"
blog_month = bl_month8
blog_short_month = bl_monthsh8
Case "09"
blog_month = bl_month9
blog_short_month = bl_monthsh9
Case "10"
blog_month = bl_month10
blog_short_month = bl_monthsh10
Case "11"
blog_month = bl_month11
blog_short_month = bl_monthsh11
Case "12"
blog_month = bl_month12
blog_short_month = bl_monthsh12
End Select

blog_date = Replace(use_format,"yyyy", blog_year,1,-1,0)
blog_date = Replace(blog_date,"yy", right(blog_year,2),1,-1,0)
blog_date = Replace(blog_date,"mm", blog_month_digit,1,-1,0)
blog_date = Replace(blog_date,"Month", blog_month,1,-1,0)
blog_date = Replace(blog_date,"month", lcase(blog_month),1,-1,0)
blog_date = Replace(blog_date,"MONTH", ucase(blog_month),1,-1,0)
blog_date = Replace(blog_date,"Mn", blog_short_month,1,-1,0)
blog_date = Replace(blog_date,"mn", lcase(blog_short_month),1,-1,0)
blog_date = Replace(blog_date,"MN", ucase(blog_short_month),1,-1,0)

ProcessArchiveDate = blog_date
End Function


%>