<%   
'    Adrian Frost - BlogWorks XML 1.3.0
'    Copyright  2002-2003  Adrian Frost
'    Released under the GNU General Public License (see LICENCE.TXT)
%>
<!-- #include file="prefs_include.asp" -->
<!-- #include file="paths.asp" -->
<!-- #include file="xmldom_check.asp" -->
<!-- #include file="timestamps.asp" -->
<!-- #include file="text_filter.asp" -->
<!-- #include file="xmlsubs.asp" -->
<!-- #include file="hash.asp" -->
<%
Dim typeFlag, incURL, isForm, incID, incTitle, incLink, incSource, incAuthor, incDescription, incName, incEmail, xmlString
' can only access the Request object as a whole here for working out the type of incoming.
' If the collections form and querystring get used the Request object gets ruined for loading as XML... Other collections
' seem to be okay though
incID = Request("id")
incExcerpt = Request("excerpt")
incSource = Request("blog_name")
isForm = Request("bwForm")

' Let's set up our XML doc to receive the incoming 'stuff'
set objXMLdoc = Server.CreateObject(bw_xmlCheck)
objXMLdoc.async = false
objXMLdoc.setProperty "SelectionLanguage","XPath" 


If incID = "" Then
	response.write "<h1>Nothing to see here</h1>" _
	& "<p>This page acts as a receiver for:<br />" _
	& "<a href=""http://www.movabletype.org/trackback"" target=""_blank"">TrackBack</a> pings " _
	& "and " _ 
	& "<a href=""http://wellformedweb.org/story/9"" target=""_blank"">CommentAPI</a> XML fragments " _
	& "<br />as part of a <a href=""http://www.blogworks.com"" target=""_blank"">BlogWorks XML</a> " _
	& "blog's ""incoming"" system. <br />" _
	& "It has absolutely no other use and really isn't that interesting.</p>"
	response.end
End If	

If isForm = "" Then
	If incExcerpt = "" and incSource = "" Then
		' presume we're dealing with XMLHTTP (or other) properly posted XML
		objXMLdoc.load(Request)
		typeFlag = "xmlItem"
	Else
		' This is a TrackBack via QueryString.
		incTitle=request.querystring("title")
		incLink = request.querystring("url")
		incSource = request.querystring("blog_name")
		incDescription = request.querystring("excerpt")

		If incLink = "" Then
			resp = "<?xml version=""1.0"" encoding=""iso-8859-1""?>" _
				& "<response>" _
				& "<error>1</error>" _
				& "<message>Linking URL missing</message>" _
				& "</response>"
			response.write resp
			response.end
		End If

		' Build an XML string to load.
		xmlString = "<?xml version=""1.0""?>" _
			& "<item>" _
			& "<title>" & incTitle & "</title>" _
			& "<link>" & incLink & "</link>" _
			& "<description>" & incDescription & "</description>" _
			& "<source>" & incSource & "</source>" _
			& "</item>"
		objXMLdoc.loadXML(xmlString)	
		typeFlag = "trackBack"	
	End If
Else
	incName = StripHTML(request.form("cmtName"),true)
	incLink = StripHTML(request.form("cmtUrl"),true)
	incEmail = StripHTML(request.form("cmtEmail"),true)
	incTitle = StripHTML(request.form("cmtSubject"),true)
	incRM = request.form("rememberMe")
	If incRM = "rM" Then
		Response.Cookies("cmtName") = incName
		Response.Cookies("cmtLink") = incLink
		Response.Cookies("cmtEmail") = incEmail
		Response.Cookies("cmtName").Expires =  now + 365	
		Response.Cookies("cmtLink").Expires =  now + 365	
		Response.Cookies("cmtEmail").Expires =  now + 365
	Else
		Response.Cookies("cmtName").Expires =  now -1
		Response.Cookies("cmtLink").Expires =  now -1
		Response.Cookies("cmtEmail").Expires =  now -1
	End If

	If incEmail <> "" Then
		incEmail = " (" & incEmail & ")"
	End If
	incDescription = StripHTML(request.form("cmtText"),true)
		If incDescription = "" Then
			resp = Request.ServerVariables("HTTP_REFERER")
			If InStr(resp,"&err=1.0") Then
				resp = left(resp,len(resp)-8)
			End If
			response.redirect resp & "&err=1.0"
			response.end
		End If

	xmlString = "<?xml version=""1.0""?>" _
		& "<item>" _
		& "<title>" & entityEncode(incTitle) & "</title>" _
		& "<link>"  & entityEncode(incLink) & "</link>" _
		& "<description>" & entityEncode(incDescription) & "</description>" _
		& "<author>" & entityEncode(incName & incEmail) & "</author>" _
		& "</item>"

	objXMLdoc.loadXML(xmlString)		
	typeFlag = "bwForm"
End If


sXPath = "//item/*"

Set objNewItem = objXMLdoc.createElement("item")
set objNodes = objXMLdoc.documentElement.selectNodes(sXPath)

For each Node in objNodes
If Instr(Node.nodeName,":") = False Then  ' refuse namespaced elements. Basic RSS 2.0 only.
	If InStr(Node.nodeName,"pubDate") = False Then
		Set objNewSubItem = objXMLDoc.createElement(node.nodeName)
		' All HTML is stripped for safety's sake - stops images, links and scripts
		objNewSubItem.text = StripHTML(node.text,true)
		objNewItem.appendChild(objNewSubItem)
	End If
End If
Next

Set objNewDate = objXMLDoc.createElement("pubDate")
time_adjust = GetConfigItem("config.xml","","timeadjust")
time_zone = GetConfigItem("config.xml","","timezone")
newTimeStamp = HumanToUnix("")
newTimeStamp = newTimeStamp + (time_adjust * 3600)
objNewDate.text = UnixtoRSS(newTimeStamp,"rfc822")
objNewItem.appendChild(objNewDate)

Set objNewCategory = objXMLDoc.createElement("category")
objNewCategory.text = typeFlag
objNewItem.appendChild(objNewCategory)

Set objNewGuid = objXMLDoc.createElement("guid")
objNewGuid.setAttribute "isPermalink","false"
objNewGuid.text = miniHash(UnixtoRSS(HumanToUnix(""),"rfc822") & typeFlag) 
objNewItem.appendChild(objNewGuid)

set fls=Server.CreateObject("Scripting.FileSystemObject")
If fls.FileExists(server.mappath(writable_dir & subIncoming & subSlash & "rx" & incID & ".xml")) = true Then
	Set objXMLchanges = Server.CreateObject(bw_xmlCheck)
	objXMLchanges.async = false 
	objXMLchanges.load(server.mappath(writable_dir & subIncoming & subSlash & "rx" & incID & ".xml"))
	Set changesRoot = objXMLchanges.documentElement
	changesRoot.appendChild objNewItem
	objXMLchanges.save(server.mappath(writable_dir & subIncoming & subSlash & "rx" & incID & ".xml"))
	set objXMLdoc = nothing
	set objXMLchanges = nothing
Else
	Set objNewXMLDoc = Server.CreateObject(bw_xmlCheck) 
	Set procTB = objNewXMLDoc.createProcessingInstruction("xml","version=""1.0"" encoding=""" & encode_as & """")
	objNewXMLDoc.appendChild(procTB)
	Set rootTB = objNewXMLDoc.createElement("incoming")
	objNewXMLDoc.appendChild(rootTB)
	Set objAttr = objNewXMLDoc.createAttribute("postid") 
	Set xmlNewRoot = objNewXMLDoc.documentElement
	xmlNewRoot.setAttribute "postid", incID 

	xmlNewRoot.appendChild objNewItem

	Set fs = Server.CreateObject("Scripting.FileSystemObject")
	If fs.FolderExists(server.mappath(writable_dir & subIncoming)) = True Then
		objNewXMLDoc.save(server.mappath(writable_dir & subIncoming & subSlash & "rx" & incID & ".xml"))
	Else
		GeneralError = "tb_rx_xml1"
	End If
	set fs = nothing
	Set objXMLDoc = nothing

End If
set fls = nothing

' responses to the various 'incomings'
Select Case typeFlag
Case "trackBack"
resp = "<?xml version=""1.0"" encoding=""iso-8859-1""?><response><error>0</error></response>"
response.write resp

Case "bwForm"
resp = Request.ServerVariables("HTTP_REFERER")
If InStr(resp,"&err=1.0") Then
	resp = left(resp,len(resp)-8)
End If
response.redirect resp

Case "pingBack"
resp = "PingBack ping received. No Errors"
response.write resp

Case "xmlItem"
' need a '200 OK' header sent here I think
End Select


Function writeFaultXML(errNum, errDesc)
	xmlText = "<?xml version=""1.0"" encoding=""" & strEncodeAs &"""?>" _
	& "<methodResponse>" _
	& "<fault>" _
	& "<value>" _
	& "<struct>" _
	& "<member>" _
	& "<name>faultCode</name><value><int>" _
	& errNum _
	& "</int></value>" _
	& "</member>" _
	& "<member>" _
	& "<name>faultString</name><value><string>" _
	& Server.HTMLEncode(errDesc) _
	& "</string></value>" _
	& "</member>" _
	& "</struct>" _
	& "</value>" _
	& "</fault>" _
	& "</methodResponse>"

writeFaultXML = xmlText
End Function
%>