<%   
'    Adrian Frost - BlogWorks XML 1.3.0
'    Copyright  2002-2003  Adrian Frost
'    Released under the GNU General Public License (see LICENCE.TXT)
%>
<%
Dim blog_title,blog_body
%>
<!-- #include file="prefs_include.asp" -->
<!-- #include file="paths.asp" -->
<!-- #include file="xmldom_check.asp" -->
<!-- #include file="apisentry.asp" -->
<!-- #include file="xmlsubs.asp" -->
<!-- #include file="adovbs.inc" -->
<!-- #include file="xmlrpc.asp" -->
<!-- #include file="timestamps.asp" -->
<!-- #include file="datetime.asp" -->
<!-- #include file="engine.asp" -->
<!-- #include file="template_functions.asp" -->
<!-- #include file="language.asp" -->
<!-- #include file="weblog_ping.asp" -->
<!-- #include file="hash.asp" -->
<!-- #include file="pingback_functions.asp" -->
<%
'enable the stuff that allows the blogger. convention.
Set blogger = new bloggerfuncs

Class bloggerfuncs

function newPost(appkey,blogid,username,password,content,publish)

ReadConfig "config.xml", blogid
If hashString(password) = passwd Then
If username = user_name Then

'generate PostId and file name.
stamp = HumanToUnix("") + (time_adjust * 3600)
' stamp = CreateTimestamp() + (time_adjust * 3600)
postTime = stamp
postCommentID = stamp & blogid
postID = stamp & blogid
newmonth = Month(Now)

If len(newmonth) = "1" Then
	newmonth = "0" & newmonth

End If

newFileName = Year(Now) & newmonth & "archive" & blogid & ".xml"

'extract headline/title from the content stream if available


If InStr(content,":H:") Then
	pos = InStr(content,":H:")
	postTitle = left(content,pos-1)

	If len(postTitle) > 100 Then
		postTitle = left(postTitle,100)
	End If

	postBody = right(content,(len(content)-(pos+2)))
Else
	postBody = content
End If

Dim pbFlag
pbFlag = true
If inStr(postBody,"[nopb]") Then
	pbFlag = false
	postBody = replace(postBody,"[nopb]","")
End If

'set the global bits.
glbLang = blog_lang
postAuthorName = nick_name
postAuthorMail = e_mail

set fls=Server.CreateObject("Scripting.FileSystemObject")

If fls.FileExists(server.mappath(writable_dir & newFileName)) = true Then
	AppendBlog newFileName
Else
	CreateBlog newFileName
	AppendBlog newFileName
End If

set fls = nothing

If publish = true Then
	' All
	PublishMainPage blogid,blog_main_file
	PublishRecentArchive blogid
	Set feedList = listNodes(blog_id,"feed","syndication.xml")
	For Each Item in feedList
		feedAlias = Item.getAttribute("alias")
		feedFileName = Item.selectSingleNode("filename").text
		output = PublishSyndicationFile(blog_id,feedFileName,feedAlias)
	Next
	Set feedList = nothing

	Set pingList = listNodes(blog_id,"ping","pings.xml")
	For Each Item in pingList
		pingFromName = Item.selectSingleNode("fromName").text
		pingFromURL = Item.selectSingleNode("fromURL").text
		pingToURL = Item.selectSingleNode("toURL").text
		pingToHost = Item.selectSingleNode("toHost").text
		PingWeblogs pingFromURL,pingFromName,pingToURL,pingToHost
	Next
	Set pingList = nothing
End If

' Do TrackBack Extraction and Pinging - use <trackback></trackback> tags to do so. - perhaps

If pbFlag = true Then
	urlList = extractURLs(postBody)
	If isArray(urlList) Then
		For i = lbound(urlList) to ubound(urlList)
			PingBack publish_url & Year(Now) & newmonth & "archive" & blog_id & archive_ext & "#" & postID,urlList(i)
		Next
	End If
End If

newPost = CStr(stamp & blogid)
Else
	writeFaultXML "12", "Please check that your username is correct", "BlogWorks XML Message"
End If
Else
	writeFaultXML "13", "Please check that your password is correct", "BlogWorks XML Message"
End If
end function



function editPost(appkey,postid,username,password,content,publish)
timestamp = ExtractTimestamp(postid)
blogid = ExtractBlogID(postid)

ReadConfig "config.xml",blogid

If hashString(password) = passwd Then
If username = user_name Then

' change to new TTD function
fileName = UnixToHuman(timestamp)
fileName = left(fileName,6) & "archive" & blogid & ".xml"

If InStr(content,":H:") Then
	pos = InStr(content,":H:")
	postTitle = left(content,pos-1)
		
	If len(postTitle) > 100 Then
		postTitle = left(postTitle,100)
	End If

	postBody = right(content,(len(content)-(pos+2)))
Else
	postBody = content
End If


SaveEditedPost fileName, postid

If publish = True Then
	' All
	PublishMainPage blogid,blog_main_file
	PublishRecentArchive blogid

	Set feedList = listNodes(blog_id,"feed","syndication.xml")
	For Each Item in feedList
		feedAlias = Item.getAttribute("alias")
		feedFileName = Item.selectSingleNode("filename").text
		output = PublishSyndicationFile(blog_id,feedFileName,feedAlias)
	Next
	Set feedList = nothing

End If

editPost = CBool(1)
Else
	writeFaultXML "12", "Please check that your username is correct", "BlogWorks XML Message"
End If
Else
	writeFaultXML "13", "Please check that your password is correct", "BlogWorks XML Message"
End If
end function



function getPost(appkey,postid,username,password)
timestamp = ExtractTimestamp(postid)
blogid = ExtractBlogID(postid)

If hashString(password) = passwd Then
If username = user_name Then

' change to new TTD function
fileName = UnixToHuman(timestamp)
dc = fileName
display_date = fileName
fileName = left(fileName,6) & "archive" & blogid & ".xml"
GetSinglePost fileName, postid

If blog_title = "" Then
	blog_content = blog_body
Else
	blog_content = blog_title & ":H:" & blog_body
End If

Set gPost = Server.CreateObject("Scripting.Dictionary")
gPost.Add "userid", "1"
gPost.Add "dateCreated", "<dateTime.iso8601>" & dc & "</dateTime.iso8601>"
gPost.Add "content", blog_content
gPost.Add "postid", postid

set getPost = gPost                            
Set gPost = nothing
Else
	writeFaultXML "12", "Please check that your username is correct", "BlogWorks XML Message"
End If
Else
	writeFaultXML "13", "Please check that your password is correct", "BlogWorks XML Message"
End If
end function



function getRecentPosts(appkey,blogid,username,password,numberOfPosts)
If hashString(password) = passwd Then
If username = user_name Then

RecentPosts = GetMultiplePosts(1,false,false,blogid,"all")

If IsEmpty(RecentPosts) Then
	writeFaultXML "31", "No Blogs available", "BlogWorks XML Message"
Else
	Set getRecentPosts = GetMultiplePosts(numberOfPosts,false,false,blogid,"all")
End If

Else
	writeFaultXML "12", "Please check that your username is correct", "BlogWorks XML Message"
End If
Else
	writeFaultXML "13", "Please check that your password is correct", "BlogWorks XML Message"
End If
end function



function deletePost(appkey,postid,username,password,publish)
timestamp = ExtractTimestamp(postid)
blogid = ExtractBlogID(postid)

ReadConfig "config.xml",blogid

If hashString(password) = passwd Then
If username = user_name Then

'take postid and get file name from it.
' change to new TTD function
genPostID = UnixToHuman(timestamp)
fileName = left(genPostID,6) & "archive" & blogid & ".xml"
DelPost fileName, postid

If publish = True Then
	' All
	PublishMainPage blogid,blog_main_file
	PublishRecentArchive blogid
	Set feedList = listNodes(blog_id,"feed","syndication.xml")
	For Each Item in feedList
		feedAlias = Item.getAttribute("alias")
		feedFileName = Item.selectSingleNode("filename").text
		output = PublishSyndicationFile(blog_id,feedFileName,feedAlias)
	Next
	Set feedList = nothing

End If

deletePost = CBool(1)
Else
	writeFaultXML "12", "Please check that your username is correct", "BlogWorks XML Message"
End If
Else
	writeFaultXML "13", "Please check that your password is correct", "BlogWorks XML Message"
End If
end function


function getTemplate(appkey,blogid,username,password,templateType)
If hashString(password) = passwd Then
If username = user_name Then

If templateType ="archiveIndex" Then
	temp_string = ReadTemplate("archiveIndex",true,true,true,blogid)
	temp_string = replace(temp_string,Chr(13) & Chr(10),vbNewLine)
Else 
	temp_string = ReadTemplate("main",true,true,true,blogid)
	temp_string = replace(temp_string,Chr(13) & Chr(10),vbNewLine)
End If

getTemplate = temp_string

Else
	writeFaultXML "12", "Please check that your username is correct", "BlogWorks XML Message"
End If
Else
	writeFaultXML "13", "Please check that your password is correct", "BlogWorks XML Message"
End If
end function

function setTemplate(appkey,blogid,username,password,template,templateType)
If hashString(password) = passwd Then
If username = user_name Then

template = replace(template,Chr(10),vbCrLf)
If templateType = "archiveIndex" Then
	resp = SplitSaveTemplate("archiveIndex", template, blogid)
Else
	resp = SplitSaveTemplate("main", template, blogid)
End If

If resp = "4.0" Then
setTemplate = CBool(1)
Else
	writeFaultXML "42", "Template not saved. Please check your installation.", "BlogWorks XML Message"
End If

Else
	writeFaultXML "12", "Please check that your username is correct", "BlogWorks XML Message"
End If
Else
	writeFaultXML "13", "Please check that your password is correct", "BlogWorks XML Message"
End If
end function



function getUsersBlogs(appkey,username,password)
If hashString(password) = passwd Then
If username = user_name Then

Set Blogs = server.CreateObject("ADODB.RECORDSET") 
Blogs.fields.append "url",adVarChar,150
Blogs.fields.append "blogid",adVarChar,10
Blogs.fields.append "blogName",adVarChar,40

Blogs.CursorLocation = adUseClient
Blogs.CursorType = adOpenStatic

Blogs.open 

Set objXMLDoc = Server.CreateObject(bw_xmlCheck)
objXMLDoc.async = false 
objXMLDoc.load(server.mappath(writable_dir & subData & subSlash & "config.xml"))
Set xmlRoot = objXMLDoc.documentElement
Set blogconfig = xmlRoot.getElementsByTagName("blog")
n_blogs = blogconfig.length

For i = 0 to n_blogs-1
	blog_id = xmlRoot.childNodes(i).getattribute("id")
	blog_name = xmlRoot.childNodes(i).childNodes(0).childNodes(0).text
	blog_main_file = xmlRoot.childNodes(i).childNodes(0).childNodes(2).text

	Blogs.addnew
	Blogs.fields("url") = publish_url & blog_main_file
	Blogs.fields("blogid") = blog_id
	Blogs.fields("blogName") = blog_name
Next

Blogs.movefirst
set getUsersBlogs = Blogs
set Blogs = nothing

Else
	writeFaultXML "12", "Please check that your username is correct", "BlogWorks XML Message"
End If
Else
	writeFaultXML "13", "Please check that your password is correct", "BlogWorks XML Message"
End If
end function


function getUserInfo(appkey,username,password)
If hashString(password) = passwd Then
If username = user_name Then

Set UserInfo = Server.CreateObject("Scripting.Dictionary")
UserInfo.Add "nickname", nick_name
UserInfo.Add "userid", "001"
UserInfo.Add "url", publish_url
UserInfo.Add "email", e_mail
UserInfo.Add "firstname", first_name
UserInfo.Add "lastname", last_name

set getUserInfo = UserInfo                            
Set UserInfo = nothing
Else
	writeFaultXML "12", "Please check that your username is correct", "BlogWorks XML Message"
End If
Else
	writeFaultXML "13", "Please check that your password is correct", "BlogWorks XML Message"
End If
End function
End Class





'Blogger API Methods
addServerFunction "blogger.newPost","blogger.newPost"
addServerFunction "blogger.editPost","blogger.editPost"
addServerFunction "blogger.getPost","blogger.getPost"
addServerFunction "blogger.getRecentPosts","blogger.getRecentPosts"
addServerFunction "blogger.deletePost","blogger.deletePost"
addServerFunction "blogger.getTemplate","blogger.getTemplate"
addServerFunction "blogger.setTemplate","blogger.setTemplate"
addServerFunction "blogger.getUsersBlogs","blogger.getUsersBlogs"
addServerFunction "blogger.getUserInfo","blogger.getUserInfo"


rpcserver

Set blogger = nothing
%>