<%   
'    Adrian Frost - BlogWorks XML 1.3.0
'    Copyright  2002-2003  Adrian Frost
'    Released under the GNU General Public License (see LICENCE.TXT)
%>
<%
msg = request.querystring("msg")
erro = request.querystring("err")
If inStr(erro,"xml") Then
erro_base = right(erro,4)
Else
erro_base = erro
End If

Select Case msg
'(0.x) Show Stoppers
Case "0.1"
display_msg = "Your server does not have the MSXML 3.0 component installed.<br />Until it is available BlogWorks <small>XML</small> will not work.<br />Please contact your server provider."
err_type = "bad"
Case "0.2"
display_msg = "Your server does allow you access to the File Scripting Object.<br />Until it is available BlogWorks <small>XML</small> will not work.<br />Please contact your server provider."
err_type = "bad"


'(1.x) Login Messages
Case "1.0"
display_msg = "<span style=""color : #000;"">Hello " & first_name & "</span>"
err_type = "good"
Case "1.1"
display_msg = "Sorry, the password file is missing, please check your installation."
err_type = "bad"
Case "1.2"
display_msg = "Please enter a valid User name."
err_type = "bad"
Case "1.3"
display_msg = "Please enter a valid Password."
err_type = "bad"

'(2.x) Posting Messages
Case "2.01"
display_msg = "Post saved"
err_type = "good"
Case "2.02"
display_msg = "Post saved and published"
err_type = "good"
Case "2.1"
	Select Case erro_base
	Case "xml1"
	err_msg = "Cannot find the correct directory&nbsp;<img src=""sys_images/more_info.gif"" alt=""Click for extra information"" width=""16"" height=""16"" border=""0"" onClick=""alert('BlogWorks couldn\'t save your post as it couldn\'t\nfind the directory as set in \'paths.asp\'\nPlease check this file, referring to the Help file if necessary');"" />"
	Case "xml2"
	err_msg = "Couldn't read XML file&nbsp;<img src=""sys_images/more_info.gif"" alt=""Click for extra information"" width=""16"" height=""16"" border=""0"" onClick=""alert('BlogWorks encountered an error reading an XML file.\nPlease contact BlogWorks support quoting code:\n" & erro & "');"" />"
	Case "xml3"
	err_msg  = "Can't add post to XML file&nbsp;<img src=""sys_images/more_info.gif"" alt=""Click for extra information"" width=""16"" height=""16"" border=""0"" onClick=""alert('BlogWorks encountered an error reading an XML file.\nPlease contact BlogWorks support quoting code:\n" & erro & "');"" />"
	Case "xml4"
	err_msg = "Can't save XML file&nbsp;<img src=""sys_images/more_info.gif"" alt=""Click for extra information"" width=""16"" height=""16"" border=""0"" onClick=""alert('BlogWorks couldn\'t save your post as it couldn\'t\n find the directory as set in \'paths.asp\'\nPlease check this file, referring to the Help file if necessary');"" />"
	Case "ping1"
	err_msg = "Weblogs.com was unavailable. Your post has been successfully saved and published though."
	Case "ping2"
	err_msg = "The response from weblogs.com contained errors. Your post has been successfully saved and published though."
	End Select

display_msg = "XML Error <span style=""color : #000"">" & err_msg & "</span>"
err_type = "bad"


'(3.x) View Messages

'(4.x) Template Messages
Case "4.0"
display_msg = "Template saved"
err_type = "good"
Case "4.1"
display_msg = "Template NOT saved <span style=""color : #000; font-size : smaller; font-weight : bolder;"">More information:</span>&nbsp;<img src=""sys_images/more_info.gif"" alt=""Click for extra information"" width=""16"" height=""16"" border=""0"" onClick=""alert('It wasn\'t possible to save the template file.\nPlease check your paths.asp file\nand also that you have the correct\ndirectory permissions for writing to the\n \'\'writable_dir\/templates\'\' directory');"" />"
err_type = "bad"
Case "4.2"
display_msg  = "Template NOT Saved  <span style=""color : #000; font-size : smaller; font-weight : bolder;"">More information:</span>&nbsp;<img src=""sys_images/more_info.gif"" alt=""Click for extra information"" width=""16"" height=""16"" border=""0"" onClick=""alert('Error due to incorrect tags that mark the beginning\nand end of the blog\'s section of the page.\nPlease check and then re-save the template.\n\nCorrect tags are:\n[+blog] and [-blog]  (BlogWorks XML)\n./startmainblog and ./endmainblog  (BBT)\n<Blogger> and </Blogger>  (Blogger)');"" />"
err_type = "bad"
Case "4.3"
display_msg  = "Chosen templates reset to original BlogWorks XML templates."
err_type = "good"

'(5.x) Settings Messages
Case "5.0"
display_msg = "Settings saved"
err_type = "good"

'(6.x) Publishing Messages
Case "6.0"
display_msg = "Publishing completed successfully"
err_type = "good"
Case "6.1"
display_msg = "There are no posts associated with this blog to publish"
err_type = "bad"


'(7.x) Delete Blog Messages
Case "7.0"
display_msg = "Deletion complete"
err_type = "good"
Case "7.1"
display_msg = "Please select a blog to delete"
err_type = "bad"

'(8.x) TrackBack RDF Auto-Detect Messages
Case "8.0"
display_msg = "TrackBacks found"
err_type = "good"
Case "8.1"
display_msg = "The required XMLHTTP object could not be initialised"
err_type = "bad"
Case "8.2"
display_msg = "Requested URL was unavailable"
err_type = "bad"
Case "8.3"
display_msg = "Requested URL was unavailable"
err_type = "bad"
Case "8.4"
display_msg = "Error parsing TrackBack RDF from the requested URL"
err_type = "bad"
Case "8.5"
display_msg = "Error parsing TrackBack RDF from the requested URL"
err_type = "bad"
Case "8.6"
display_msg = "There was no TrackBack RDF at the requested URL"
err_type = "bad"

'(9.x) Category Messages
Case "9.0"
display_msg = "New category created"
err_type = "good"
Case "9.01"
display_msg = "New default category set"
err_type = "good"
Case "9.02"
display_msg = "Category updated"
err_type = "good"
Case "9.1"
display_msg = "Selected category is already the default category"
err_type = "bad"
Case "9.2"
display_msg = "Category could not be updated"
err_type = "bad"


'(10.x) Category Messages
Case "10.0"
display_msg = "New syndication feed created"
err_type = "good"
End Select
%>