<%
'    Adrian Frost - BlogWorks XML 1.1.0
'    Copyright  2002-2003  Adrian Frost
'    Released under the GNU General Public License (see LICENCE.TXT)
%>
<%
Dim admin_dir,writable_dir,publish_dir,images_dir,images_rel,admin_rel,server_name,dir

Function urlTodir(url)
server_name = request.servervariables("SERVER_NAME")
server_name = "http://" & server_name

If right(url,1) <> "/" Then
	url = url & "/"
End If

dir = right(url,len(url)-len(server_name))
urlTodir = dir
End Function


publish_dir = urlTodir(publish_url)
admin_dir = urlTodir(admin_url)
writable_dir = urlTodir(writable_url)
images_dir = urlTodir(images_url)

' This is to create a relative directory structure for use in #includes in the template.
' If the admin_dir isn't a sub directory to publish_dir we really don't want to do anything though - so we'll use
' the override variables instead.

If adminRelOverride <> "" Then
admin_rel = adminRelOverride
ElseIf len(publish_url) > (admin_url) Then
admin_rel = adminRelOverride
Else
admin_rel = right(admin_dir,len(admin_dir)-len(publish_dir))
End If

' same here
If imagesRelOverride <> "" Then
	images_rel = imagesRelOverride
ElseIf len(publish_url) > len(images_url) Then
	images_rel = imagesRelOverride
Else
	images_rel = right(images_url,len(images_url)-len(publish_url))
End If


' Sub directories of writable_dir. 
' Used in conjunction with the "runFlat" variable.
Dim subBackup, subData, subIncoming, subTemplates, subLogs, subProfiles, subSlash, subDefs


If runFlat = true Then
	subBackup = ""
	subData = ""
	subIncoming = ""
	subTemplates = ""
	subLogs = ""
	subProfiles = ""
	subDefs = ""
	subSlash = ""
Else
	subBackup = "backup"
	subData = "data"
	subIncoming = "incoming"
	subTemplates = "templates"
	subLogs = "logs"
	subProfiles = "profiles"
	subDefs = "defs"
	subSlash = "/"
End If

Sub LogIt(strInput, callingFunc, logFile)
	'If eventLogging = true Then
		' Small sub that allow any string to be logged from 
		' anywhere in BW. For debugging purposes only
		' Each file is cumulative
		' ---------------------------------------
		set fileObj = Server.CreateObject("Scripting.FileSystemObject")
		fname = (server.mappath(writable_dir & subData & subSlash & subLogs & subSlash & logFile))
		set txtfile = fileObj.OpenTextFile(fname,8,true)
		txtfile.writeline "----  " & Date & " " & Time & " ----"
		txtfile.writeline "Result: " & strInput
		txtfile.writeline "Calling Function: " & callingFunc
		txtfile.writeline "-----------------------------"
		txtfile.close
		set txtfile = nothing
		set fileObj = nothing
	'End If
End Sub
%>