<%   
'    Adrian Frost - BlogWorks XML 1.3.0
'    Copyright  2002-2003  Adrian Frost
'    Released under the GNU General Public License (see LICENCE.TXT)
%>
<%
' The prefs.asp file contains settings that I decided not to include in the settings page
' mainly because they weren't important enough or weren't worth making into a major choice.
' If you got this far you're probably interested in customising BlogWorks XML further so feel free to play :)
' Each setting is detailed with possible options.

Dim entitiesdropdown,accentcharsdropdown,linebreaktag,boldtag,italictag,imagetagend,display_default,encode_as,show_toolbars,server_port,comment_rdf

' Entities Dropdown - in New & Edit Post pages, add HTML entities from a dropdown list.
' Either 'ON' or 'OFF'. 'OFF' by default.
entitiesdropdown = "OFF"


' Accented Characters Dropdown - in New & Edit Post pages, add accented characters from dropdown list.
' Either 'ON' or 'OFF'. 'OFF' by default.
accentcharsdropdown = "OFF"


' Items relating to type of markup used - XHTML or HTML 4.0
' Linebreak used when converting carriage returns in body text. Either '<br>' or '<br />' or '<BR>'
linebreaktag = "<br />"


' For purists, set how the tags used for bold and italic
' For bold - either '<b></b>' or '<strong></strong>'
' For italics - either '<i></i>' or '<em></em>'
boldtag = "<b></b>"
italictag = "<i></i>"


' For image tags - the last characters of the tag.
' Either use - ' />' (xhtml) or '>' (html4)
imagetagend = " />"


' Default number of posts to show in bloglist.asp (View Posts)
display_default = "5"


' Toolbars. Turn toolbar text on and off: Show text = "text", Don't show text = "no-text"
show_toolbars = "text"


' XML Encoding - this is real geekdom, leave it as set unless you know otherwise :-)
encode_as = "ISO-8859-1"


' Server Port - if you need to use a non standard server port enter the number (excluding the ":") 
' between the quotes, else leave it blank.
server_port = ""


'TrackBack RDF
'Comment out RDF for XHTML validation purposes ("yes" or "no")
comment_rdf = "yes"
%>