<% Response.buffer = true %>
<%  
'    Adrian Frost - BlogWorks XML 1.3.0
'    Copyright  2002-2003  Adrian Frost
'    Released under the GNU General Public License (see LICENCE.TXT)
%>
<!-- #include file="system_includes.asp" -->
<!-- #include file="template_functions.asp" -->
<%
ttype = request.querystring("alias")
action = request.form("submitedit")
reset = request.querystring("reset")

' The ability to reset templates to the original templates as shipped with BW would be useful.
' simply, when on the template_editor.asp page append ?reset= (or &reset= if there is already an ? in the URL) to the URL and then add any of the four codes with + inbetween
' mb - Main Blog page template
' ai  - Archive Index template
' ap - Archive Pages template
' rss - RSS Feed template
' Should give a URL like: http://www.mysite.com/admin_dir/template_editor.asp?reset=mb+ai+ap+rss
' This is the only documentation you'll find on this feature :-)

If reset <> "" Then
	If Instr(reset,"mb") Then
		strHTML = ReadOriginalTemplate("maindef.htm")
		SplitSaveTemplate "main",strHTML,blog_id
	End If

	If Instr(reset,"ai") Then
		strHTML = ReadOriginalTemplate("archivedef.htm")
		SplitSaveTemplate "archiveIndex",strHTML,blog_id
	End If

	If Instr(reset,"ap") Then
		strHTML = ReadOriginalTemplate("archivepagesdef.htm")
		SplitSaveTemplate "archivePages",strHTML,blog_id
	End If

	If reset= "all" Then
		strHTML = ReadOriginalTemplate("maindef.htm")
		SplitSaveTemplate "main",strHTML,blog_id
		strHTML = ReadOriginalTemplate("archivedef.htm")
		SplitSaveTemplate "archiveIndex",strHTML,blog_id
		strHTML = ReadOriginalTemplate("archivepagesdef.htm")
		SplitSaveTemplate "archivePages",strHTML,blog_id
	End If
	response.redirect "template_editor.asp?msg=4.3"
End If


If action = "" Then
	If ttype = "" Then
		If msg = "4.1" Then
			template_text = ReadBackupTemplate("main",blog_id)
			template_text = replace(template_text,"&","&amp;")
		Else
			template_text = ReadTemplate("main",true,true,true,blog_id)
			template_text = replace(template_text,"&","&amp;")
		End If
		temp_type = "main"
	Else
		If msg = "4.1" Then
			template_text = ReadBackupTemplate(ttype,blog_id)
			template_text = replace(template_text,"&","&amp;")
		Else
			template_text = ReadTemplate(ttype,true,true,true,blog_id)
			template_text = replace(template_text,"&","&amp;")
		End If
		temp_type = ttype
	End If
Else
	temp_type = action
	template_text = ReadTemplate(action,true,true,true,blog_id)
End If
%>
<?xml version="1.0"?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xml:lang="en" xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>BlogWorks XML&nbsp;&nbsp;(<%= titlTemplates %><%= blog_name %>)</title>
<link rel="stylesheet" href="adminbasic.css" type="text/css" />
<style type="text/css" media="all">
@import "admin.css";
</style>
<!-- #include file="scripts.htm" -->
</head>
<body>
<% If bwBar = true Then %>
<table border="1" cellpadding="2" cellspacing="0" width="100%" class="header">
  <tr>
    <td valign="top"><a href="javascript:openWindow('session_info.asp','350','200','session')" onMouseover="statbar('<%= sbDebugWindow %>'); return true;"  onMouseOut="statbar('');"><img src="sys_images/dbg_button.gif" alt="" width="27" height="27" border="0" class="xb" /></a><img src="sys_images/bw-banner.gif" alt="BlogWorks XML <%= bw_release %>" width="375" height="27" border="0" class="xb" /></td>
    <td valign="middle" align="right"><h1><%= titlTemplates %> <strong><%= blog_name %></strong></h1></td>
  </tr>
</table>
<% End If %>
<!-- #include file="menubar.asp" -->
<!-- #include file="buttonbar2.asp" -->
<div id="content">
<% If msg <> "" Then %><p><strong class="<%= err_type %>"><%= display_msg %></strong></p><% End If %>
<form action="template_editor.asp" method="post" name="form0">
<table border="0" cellpadding="0" cellspacing="0">
<tr valign="top">
<td>
<strong><small><%= infEditing %>:</small></strong>
</td>
<td>&nbsp;
<select name="submitedit" onChange="submit()">
<option value="main" disabled="disabled" style="font-weight:bold;">---- General Templates ----</option>
<option value="main" <% if temp_type="main" Then %>selected="selected"<% End If %>>&nbsp;<%= infMainBlogPage %></option>
<option value="archiveIndex" <% if temp_type="archiveIndex" Then %>selected="selected"<% End If %>>&nbsp;<%= infArchiveIndexPage %></option>
<option value="archivePages" <% if temp_type="archivePages" Then %>selected="selected"<% End If %>>&nbsp;<%= infArchivePages %></option>
<%
Set catList = listNodes(blog_id,"category","categories.xml")

If catList.length <> 0 Then
response.write "<option value=""main"" disabled=""disabled"">&nbsp;</option>"
response.write "<option value=""main"" style=""font-weight:bold;"" disabled=""disabled"">---- " & infCatPages & " ----</option>"
End If

For Each Item in catList
	catName = Item.selectSingleNode("name").text
	catID = Item.selectSingleNode("id").text
	catAlias = Item.getAttribute("alias")
	
	If temp_type = catAlias Then
		response.write "<option value=""" & catAlias & """ selected=""selected"">&nbsp;" & catName & "&nbsp;&nbsp;&nbsp;(" & catID & ")</option>" & vbCrLf
	Else
		response.write "<option value=""" & catAlias & """>&nbsp;" & catName & "</option>" & vbCrLf
	End If
Next
Set catList = nothing

Set feedList = listNodes(blog_id,"feed","syndication.xml")

If feedList.length <> 0 Then
response.write "<option value=""main"" disabled=""disabled"">&nbsp;</option>"
response.write "<option value=""main"" style="" font-weight:bold;"" disabled=""disabled"">---- " & infSyndFeeds & " ----</option>"
End If

For Each Item in feedList
	feedName = Item.selectSingleNode("name").text
	feedAlias = Item.getAttribute("alias")
	
	If temp_type = feedAlias Then
		response.write "<option value=""" & feedAlias & """ selected=""selected"">&nbsp;" & feedName & "</option>" & vbCrLf
	Else
		response.write "<option value=""" & feedAlias & """>&nbsp;" & feedName & "</option>" & vbCrLf
	End If
Next
Set feedList = nothing

%>
</select
</td>
</tr>
</table>
</form>
<form action="template_process.asp" method="post" name="form1">
<textarea name="template" id="template" rows="15" cols="100"><%= template_text %></textarea>
<p>
<input type="submit" name="submit" value="<%= btnSaveTemplate %>" class="hand" />
<input type="hidden" name="templateType" value="<%= temp_type %>" />
</p>
</form>
</div>
<div class="copyright">
<!-- #include file="copyright.asp" -->
</div>
</body>
</html>